#!/usr/bin/perl -w
# Полуавтоматический регистратор учетных записей для игры Divide and Conquer (http://www.the-game.ru)
# с возможностью запуска на зарегистрированных учетных записях (аккаунтах) внутреигровых скриптов.
# v. 1.32 (08.07.2009)
# b00
use strict;
use LWP::UserAgent;
use HTTP::Cookies;
use Compress::Zlib;
use Digest::MD5 qw(md5_hex);
$0 = "DnC account registrator";
# Это можно менять при необходимости:
my $conffile = 'autocrazy_dnc.rc'; # путь и имя основного конфига. по умолчанию  - рабочая директория скрипта
my $raceconf = 'autocrazy_randrace.rc'; # путь и имя к параметрам расы (если раса не стандартная). --- // ----
my $acc_db = 'created_accounts.csv'; # путь и имя к логу созданных акков. --- // ---
my @vis_accname_chars = ("a" .. "z", 0 .. 9); # Массив c шаблонами для генерации ВИДИМОГО имени (или его остаточной части).
my $base_url = 'http://www.the-game.ru/'; # этот параметр без нужды менять не стоит.
# Дальше ничего менять не надо, если вы не знаете, что делаете!
############# PROGRAMM #############
# иниализация всякой фигни
$|=1; my ($acc_id);
# do {&Usage;	exit;} if ($ARGV[0] eq '-h' or $ARGV[0] eq '--help'); # выводим хелп если указаны соотв. ключи
my %User_Preferences = &ReadConfig($conffile);	# читаем конфиг, получаем хэш с настройками
my %RaceParams = &ReadRaceParams($raceconf); # считать параметры расы
my $browser = &UAInit();						# инициализация азер-агент для клиента

# начало творческой деятельности скрипта
my ($login_password,$visible_name) = &CreateAccName;	# генерация имени для входа, пароля и видимого имени
&RegisterAcc($visible_name,$login_password);	# регистрация акка

# берем число попыток подбора координат ХВ из конфига, иначе - вычисляем кол-во попыток подбора, если это указано в конфиге
my $selection_count = $User_Preferences{"selection_count"};
$selection_count = int((100- $RaceParams{"start_t"})/ $RaceParams{"delta_t"}) if ($User_Preferences{"selection_count"} eq 'auto');

# начинаем подбор координат ХВ
for (0..$selection_count){
	# здесь начинаются варианты посадки расы и подбора температуры для поиска ХВ; в дальнейшем возможно добавление перебора природа-первичка
		my $captcha_page_get_url = $base_url.'createrace/?race-name='.$visible_name.'&racenature='.$RaceParams{"racenature"}.'&industrynature='.$RaceParams{"industrynature"}.'&t-optimal='.$RaceParams{"start_t"}.'&zanud='.$RaceParams{"zanud"}.'&spec='.$RaceParams{"spec"}.'&nomads='.$RaceParams{"nomads"}.'&longlife='.$RaceParams{"longlife"}.'&intell='.$RaceParams{"intell"}.'&old='.$RaceParams{"old"}.'&traiders='.$RaceParams{"traiders"}.'&small='.$RaceParams{"small"};
		my ($captcha_value,$captcha_md5,$cap_digest) = &CaptchaRecognize($captcha_page_get_url); # распознавание капчи
		my $HW_coord = &AccountPositioning($captcha_value,$captcha_md5,$visible_name,$cap_digest);	# подбор координат ХВ для посадки акка из предлагаемого сервером списка
		if ($HW_coord){ # если подобрали координаты ХВ - можно идти дальше
			$acc_id =  &CreateAccount($HW_coord,$visible_name,$captcha_value,$captcha_md5); # сажает аккаунт, в подтверждение получаем ID созданного аккаунта.
			last if ($acc_id); # заканчиваем цикл подбора координат, если аккаунт посажен
		}
		else { # иначе продолжаем подбор
			$RaceParams{"start_t"} += $RaceParams{"delta_t"}; # меняем температуру на шаг дельта_т
			print 'All HW blocked. Repeat with the t= '. $RaceParams{"start_t"}. " deg...\n";
		}
#	print "Available HW not found. End over.\n";
}

# если аккаунт успешно посажен - активируем подписку и запускаем указанный в конфиге скрипт
if ($acc_id){
	my $script_id = &SubscrActiv($base_url) if $User_Preferences{"start_script"};
	# возможно тут будут какие-то еще действия с акком, поэтому проверка на необходимость включения скрипта сделана вложенной
}
&LogOff($base_url); # отключение от сервера
exit;
############# PROCEDURES  #############
sub ReadConfig($){ # читаем основной конфиг, запоминаем настройки
# Чтение конфигурационного файла, установка параметров работы программы.
# Возвращает хэш с параметрами конфигурации.
open (CONFIG,"<",$conffile) or die "Can't open configuration file: $!";
while (<CONFIG>){
	chomp;
	s/#.*//;
	s/^\s+//;
	s/\s+$//;
	next unless length;
	my ($var, $value) = split (/\s*=\s*/, $_, 2);
	$User_Preferences{$var} = $value;
}
close (CONFIG);
print "Config read OK. Done.\n";
return %User_Preferences;
}

sub ReadRaceParams($){ # читаем параметры расы для акка, настройки подбора температуры
 # Чтение файл с параметрами расы, возвращает хэш с ними же.
 open (RACE_PARAM,"<",$raceconf) or die "Can't open race configuration file: $!";
 #my %RaceParams;
 while (<RACE_PARAM>){
	chomp;
	s/#.*//;
	s/^\s+//;
	s/\s+$//;
	next unless length;
	my ($var, $value) = split (/\s*=\s*/, $_, 2);
	$RaceParams{$var} = $value;
 }
 close (RACE_PARAM);
 print "Race parameters read OK. Done.\n";
 return (%RaceParams);
}

sub CreateAccName{ # генерация видимого имени акка и пары Логин=Пароль
=head1
CreateAccName - по указанному шаблону (-или массиву слов-) генерирует
видимое игровое имя аккаунта, случайным образом создает имя и пароль
для входа. 
-Результат записывается в БД для избежания повторений.-
=cut
my $login_password;
my $visible_name = $User_Preferences{"acc_basename"};
for (1 .. $User_Preferences{"pwd_length"}){ # генерируем пароль заданной длины
	$login_password .= chr ${[33..122]}[int(rand(122-32))] # случайные символы выбираются через их коды и приклеиваются в хвост переменной
}
$visible_name .= join("", @vis_accname_chars[ map { rand @vis_accname_chars } (1 .. $User_Preferences{"tail_length"}) ]); # генерация видимого имени акка
$login_password =~ s/;/?/; # заменяем в логине и пароле точку с запятой на воопр. знак, т.к. разделитель в csv - тчк. с зпт. (чтобы лог затем легче парсился splito'м и пинговалка обходила акии)
print "$visible_name: account name and password generated. Done.\n";
return ($login_password,$visible_name);
}

sub UAInit(){ # инициализация юзер-агента, прикидываемся браузером
 my $cookies=HTTP::Cookies->new('file'=>'./cookies.lwp','autosave'=>0);
 my $browser=LWP::UserAgent->new('agent' => 'Mozilla/5.0 (Windows; U; Windows NT 5.1; ru; rv:1.9.0.11) Gecko/2009060215 Firefox/3.0.11)',
								  'cookie_jar' => $cookies,
								  'requests_redirectable' => ['GET', 'POST']);
 $browser->default_header('Accept' => 'text/html, application/xml;q=0.9, application/xhtml+xml, image/png, image/jpeg, image/gif, image/x-xbitmap, */*;q=0.1',
						'Accept-Charset' => 'utf-8; *;q=0.1',
						'Accept-Language' => 'ru,en-us;q=0.7,en;q=0.3',
						'Accept-Encoding' => 'deflate, gzip, x-gzip, identity, *;q=0',
						);
 if ($User_Preferences{"proxy_addr"} and $User_Preferences{"proxy_port"}){
	$browser->proxy([qw(http https)], $User_Preferences{"proxy_addr"} . ':' . $User_Preferences{"proxy_port"});
	print 'Proxy enabled: '. $User_Preferences{"proxy_addr"} . ':' . $User_Preferences{"proxy_port"}, "\n";
 }
 return ($browser);
}

sub RegisterAcc($$){ # регистрируем акк в игре, в случае неудачи - останов скрипта
=head1
RegisterAcc - отправляет необходимые для регистрации нового аккаунта
данные на сервер, получает с сервера captcha, выдает на распознавание пользователю
или OCR, отсылает на сервер распознанный код, заданные параметры расы (или
номер одной из стандартных рас - задается в конфиге). Проверяет попадание аккаунта
в нужный район (районы), при необходимости подбор параметров расы повторяется.
=cut
my ($visible_name,$login_password) = @_;
## Генерация и отправка на сервер данных для регистрации нового аккаунта.
# my $acc_lang = int(rand(2)); #Случайная генерация языка аккаунта 0 - ENG, 1 - RUS
my $acc_lang = 1; # выставил русский, т.к. потрошилка логов логи на английском не ест ((
my $acc_sex = int(rand(2)); #Случайная генерация языка аккаунта 0 - MALE, 1 - FEMALE
my $acc_yearbirn = int(rand(30))+1965; #Случайная генерация года рождения
my $response = $browser->post ($base_url.'register',
		[
		action		=>	'register',
		name		=>	$visible_name,
		login		=>	$login_password,
		pwd			=>	$login_password,
		pwd1		=>	$login_password,
		mail		=>	'',
		lang		=>	$acc_lang,
		sex			=>	$acc_sex,
		yearbirn	=>	$acc_yearbirn,
		invitedby	=>	'',
		]);
	print "$visible_name: data sended. Log/Pass: $login_password   Server response: ".$response->status_line, "\n" if $response->is_success;
	die ("Connection error: ".$response->status_line,"\n") unless $response->is_success;
}

sub CaptchaRecognize($){ # получаем ссылку на капчу, распознаем ее, вычисляем для нее чексумму, сравниваем с базой капч
=head1
CaptchaRecognize - производит разбор капчи в ручном или автоматическом режиме.
1. Ручное распознование (скрипт предложит пройти по ссылке
и затем ввести значение капчи в окне консоли);
В планах:
2. Автоматическое распознавание с использованием API,
предостваляемых сервисом "captchakiller.com" (необходима
регистрация на сервисе, не более 20 попыток распознавания
в сутки).
=cut
my $captcha_page_get_url = $_[0];
my ($captcha_value,$captcha_md5);
## получаем информацию для дополнения базы с хэшами и значениями капч и для проверки текущей капчи по базе
my $response = $browser->get($captcha_page_get_url);	# получаем файл с капчей
 my $cap_digest = md5_hex($response->content);	#  вычисляем чексумму для капчи
## проверка капчи по базе
 open (CAP_DB, '<', './autocrazy_cap_md5.db');
 while (<CAP_DB>){
	my ($var, $value) = split (/\s*=\s*/, $_, 2);
	do {$captcha_value = $value; last;} if $var eq $cap_digest;
 }
 close (CAP_DB);
## если в базе не нашли - начинаем пробовать руками
if (!$captcha_value){ 
 # Получение и парсинг страницы, содержащей ссылку на капчу.
 $response = $browser->get($captcha_page_get_url);
	die ("Connection error: ".$response->status_line,"\n") unless $response->is_success;
 my $source = Compress::Zlib::memGunzip(\($response->content)[0]);
 $captcha_md5 = $1 if $source =~ m#<img src=".*?/static/img/captcha/([0-9a-z]+)\.png"#; # получаем значение чексуммы капчи, передаваемое сервером.
 my $cap_url = $base_url.'static/img/captcha/'.$captcha_md5.'.png'; # создаем прямую ссылку на картинку с капчей, она нужна для удобства работы.
 # Ручное распознавание капчи путем выдачи пользователю ссылки на файл с капчей и получения ответа от пользователя
  if ($User_Preferences{"captcha_recognize"} eq 'browser'){
	print 'Pleas follow to this link: '.$cap_url,"\n";
	print "and enter CAPTCHA: ";
	$captcha_value = <>; # ждем ввод капчи
	chomp ($captcha_value);
  }
 # выводим картинку при помощи утилиты display (imagemagick)
  elsif ($User_Preferences{"captcha_recognize"} eq 'display'){
	  system ("display $cap_url &"); # выводим картинку с капчей в окошке
	  print "Enter CAPTCHA: ";
	  $captcha_value = <>; # ждем ввод капчи
	  chomp ($captcha_value);
  }
 # конвертация и вывод в ASCII-виде в консоль
  elsif ($User_Preferences{"captcha_recognize"} eq 'ascii'){
	  $response = $browser->get($cap_url, # получаем картинку с капчей
		':content_file' => './cap_tmp.png'); # сохраняем ее во временный файл
	  system ("convert cap_tmp.png cap_tmp.pbm; pbmtoascii cap_tmp.pbm"); # конвертируем .png в .pbm, конвертируем .pbm в ASCII-графику.
	  print "Link to captcha img: $cap_url\nEnter CAPTCHA: ";
	  $captcha_value = <>; # ждем ввод капчи
	  chomp ($captcha_value);
	  # уничтожаем временные файлы, выводим предупреждение, если не удалось уничтожить
	  unlink ("cap_tmp.png") || warn "Temporary file not deleted: $!\n"; 
	  unlink ("cap_tmp.pbm") || warn "Temporary file not deleted: $!\n";
  }
  # машинное распознавание капчи... может будет когда-то
  elsif ($User_Preferences{"captcha_recognize"} eq 'robot'){
	die "Maschine CAPTCHA recognizing under construction";
  }
}
# конец работы функции	
return ($captcha_value, $captcha_md5, $cap_digest);
}

sub AccountPositioning($$$){ # проверяем список выданных ХВ на соответствие заданным координатам
=head1
AccountPositioning - высаживает аккаунт внутри границ
заданной области (или областей). При отстутсвии свободных ХВ
внутри указанных границ пытается сгенерировать новую расу,
добиваясь попадания в нужную область.
=cut
my ($captcha_value, $captcha_md5, $visible_name, $cap_digest) = @_;
#my %RaceParams = %_;
my ($HW_coord);
# передаем параметры расы, получаем в ответ список доступных ХВ
my $HW_get_url = $base_url.'makenewrace/?capcode='.$captcha_value.'&capachamd5='.$captcha_md5.'&racenature='.$RaceParams{"racenature"}.'&industrynature='.$RaceParams{"industrynature"}.'&race-name='.$visible_name.'&t-optimal='.$RaceParams{"start_t"}.'&zanud='.$RaceParams{"zanud"}.'&spec='.$RaceParams{"spec"}.'&nomads='.$RaceParams{"nomads"}.'&longlife='.$RaceParams{"longlife"}.'&intell='.$RaceParams{"intell"}.'&old='.$RaceParams{"old"}.'&traiders='.$RaceParams{"traiders"}.'&small='.$RaceParams{"small"};
## запрос к серверу для получения страницы со списком ХВ
my $response = $browser->get ($HW_get_url); 
	die ("Connection error: ".$response->status_line,"\n") unless $response->is_success;
my $source = Compress::Zlib::memGunzip(\($response->content)[0]);
# если капча протухла или кривая - повторяем разбор капчи в основном цикле for (в теле программы).
if ($source =~ m#class="error">(Неверный код.|Wrong code.)#){
	print "Wrong captch code. Please re-enter.\n";
	redo;
}
# иначе считаем что капча прошла и идем дальше
	# кладем чексумму и значение капчи в файл
	open (CAP_DB, '>>', './autocrazy_cap_md5.db');
		print CAP_DB $cap_digest. ' = '. $captcha_value, "\n";
	close (CAP_DB);
 # проверяем координаты выданных сервером ХВ на условие удовлетворения заданной области
 while ($source =~ m#value="(\d{1,4}):(\d{1,4})#g){ # проверка попадания в  область
	# соответствие прямоугольной области
	if ($User_Preferences{"coord_left"} and $User_Preferences{"coord_right"} and $User_Preferences{"coord_top"} and $User_Preferences{"coord_bottom"}){
		if ($User_Preferences{"coord_left"} <= $1 and $1 <= $User_Preferences{"coord_right"} and $User_Preferences{"coord_bottom"} <= $2 and $2 <= $User_Preferences{"coord_top"}){
			$HW_coord = $1 . ':' . $2;
			last;
		}
	}
	# соответствие области в виде окружности с координатами точки центра и величиной радиуса
	elsif ($User_Preferences{"coord_center_x"} and $User_Preferences{"coord_center_y"} and $User_Preferences{"coord_radius"}){
		my $tmpX = $1; my $tmpY = $2;
		# print "$tmpX\t$tmpY\n";
		if (my $tmp_rad = sqrt(($User_Preferences{"coord_center_x"} - $tmpX)**2 + ($User_Preferences{"coord_center_y"} - $tmpY)**2) <= $User_Preferences{"coord_radius"}){
			$HW_coord = $tmpX . ':' . $tmpY;
			last;
		}
	}
 }
return ($HW_coord);
}

sub CreateAccount($$$$){ # сажаем акк на ХВ
=head1
CreateUSRAccount - сажает акк (С ПОЛЬЗОВАТЕЛЬСКОЙ РАСОЙ) с удовлетворяющими заданной области координатами, выводит
данные (логин, пароль, координаты ХВ, ID) в лог-файл. ID может быть использован для
дальнейшего мониторинга состояния программами типа dcstat.
=cut
 my ($HW_coord,$visible_name,$captcha_value,$captcha_md5) = @_;
 my $acc_id;
 my $response = $browser->post($base_url.'chooseplanetandrace/',
	[
	capcode				=>	$captcha_value,
	capachamd5			=>	$captcha_md5,
	'race-nature'		=>	$RaceParams{"racenature"},
	'industry-nature'	=>	$RaceParams{"industrynature"},
	'race-name'			=>	$visible_name,
	't-optimal'			=>	$RaceParams{"start_t"},
	zanud				=>	100- $RaceParams{"zanud"},
	spec				=>	100- $RaceParams{"spec"},
	nomads				=>	100- $RaceParams{"nomads"},
	longlife			=>	100- $RaceParams{"longlife"},
	intell				=>	100- $RaceParams{"intell"},
	old					=>	100- $RaceParams{"old"},
	traiders			=>	100- $RaceParams{"traiders"},
	small				=>	100- $RaceParams{"small"},
	planetid			=>	':',
	action				=>	'makenewrace',
	planet				=>	$HW_coord,
	]);
	if ($response->is_success){
		my $source = Compress::Zlib::memGunzip(\($response->content)[0]);
		$acc_id = $1 if $source =~ m#var PlayerId=(\d+);#;
		if ($acc_id){ # если акк засажен - подпишем его на канал "мастер-крейзи" и выведем инфу по нему в лог
			$response = $browser->get($base_url. '/blackframes/mysubscriptions/on/0/?action=subscribe_me_to&channel=4123&mode=0');
			print "Account now created. Log/Pass: $login_password\t HW coordinates: $HW_coord. Account ID: $acc_id. Server response: ".$response->status_line, "\n";
			open (ACC_BASE,'>>',$acc_db);
				$HW_coord =~ s/:/ ; /;
				print ACC_BASE "$HW_coord ; $visible_name ; $login_password ; $login_password ; $acc_id\n";
			close (ACC_BASE);
		}
	}
 #конец блока посадки акка
return ($acc_id);
}

sub SubscrActiv($){ # активируем пробную подписку, запускаем указанный в конфиге скрипт
=head1
SubscrActiv - активирует на созданном аккаунте пробную подписку и запускает
на выполнение копию заданного в конфиге скрипта.
=cut
 my ($script_id);
 my $base_url = $_[0];
 $base_url =~ s/www/free/; # меняем адрес по умолчанию
 print 'Activation subscribe and start game script '.$User_Preferences{"start_script"}, " ...\n";
 # запускаем активацию пробной подписки
 my $response = $browser->get($base_url. 'blackframes/trial_subscription/on/0/?action=activate_free_subscription');
	die ("Subscribe activation error: ".$response->status_line,"\n") unless $response->is_success; # завершение, если не удалось активировать подписку
 my $source = Compress::Zlib::memGunzip(\($response->content)[0]);
 if ($source =~ m#.+(уже активизирована|was activated)#){  # если подписка активирована, идем дальше
	print "Subscribe was activated.\n";
	 my $script_name = 'herznaetchto'; # умолчальное имя запускаемого скрипта
	 $script_name = $1 if ($User_Preferences{"start_script"} =~ m#.+/(crazyscript)\.txt+#); # или берем имя скрипта из конфига, если оно там задано верно
 # подготовка игрового скрипта для отправки на сервер
	open (SCRIPT_BODY,'<',$User_Preferences{"start_script"});
	undef $/;
	my $script_body = <SCRIPT_BODY>; # в этой переменной будет лежать текст скрипта
	close (SCRIPT_BODY);
  ## Вариант создания скрипта без флота (старые скрипты могут это не поддерживать).
	# создаем стандартный скрипт "автораспаковка на таможнях", присвоив ему свое имя
	$response = $browser->post ($base_url.'blackframes/saved_static_script/on/1/',
		[
		action			=>	'mass_unpack_save', # какой скрипт создаем
		priority		=>	'100',	# "вес" игрового скрипта
		script_title	=>	$script_name, # имя скрипта
		unload			=>	'0', # параметр автораспаковщика (0 - не разгружать флоты)
		]);
			die ("Script starting error: ".$response->status_line,". Please start manually.\n") unless $response->is_success; # завершение, если не удалось создать стандартный скрипт
	$source = Compress::Zlib::memGunzip(\($response->content)[0]);
	if ($source =~ m#.+(успешно сохранен|successfully saved)#){ # идем дальше, если сервер говорит, что скрипт создался
		print "Script $script_name successfully saved\n";
		$response = $browser->get($base_url. 'frames/static_scripts/on/tools/'); # получаем фрейм со списком запущенных скриптов
		$source = Compress::Zlib::memGunzip(\($response->content)[0]);
		if ($source =~ m#<strong>$script_name</strong>.+;script=(\w+)"#){ # выдираем из кода фрейма ИД созданного нами скрипта, если успешно - идем дальше
			# отправляем скрипт на сервер в режиме сохранения
			$response = $browser->post($base_url. 'frames/edit_static_script/on/'. $1. '/', # отправляем на сервер текст игрового скрипта, указанного в конфиге
			[
			action			=>	'update_fleet_variable', # обновить игровой скрипт
			fleet			=>	'', # скрипт не привязан к флоту
			storedvar		=>	'',
			title			=>	$script_name, # имя нашего скрипта
			bbcode			=>	'1', # в отчетах о выполнении игрового скрипта будет применяться форматирование с ББ-кодами
			priority		=>	'100', # "вес" игрового скрипта
			script_text		=>	$script_body, # тело игрового скрипта
			save			=>	'Save+and+exit', # метод сохранения - сохранить и выйти. скрипт будет запущен после расчета хода
			]);
			# и еще раз отправляем скрипт на сервер, теперь в режиме тестового запуска (чтобы не ждать ход)
			$script_body = ''; # очищаем переменную
				warn ("Script edit error: ".$response->status_line,"\n") unless $response->is_success; # если запрос не удался - предупреждаем
			if ($response->is_success){
				print "Script ID= $1 edited and saved. Server response: ". $response->status_line, "\n";
				$script_id = $1;
			}
		}
	}
 }
return ($script_id);
}

sub LogOff($){ # отключаемся от сервера
# Производит отключение от сервера the-game.
my $base_url = $_[0];
$base_url =~ s/www/free/;
my $response = $browser->get($base_url. 'logoff/');
	print "Logged off. Server response: ".$response->status_line, "\n" if $response->is_success;
}

=head
Просмотр гарнизона планеты
http://www.the-game.ru/frames/planet_fleets/on/planet/?planetid=1837:379&p=436700_1#null

GET-запрос для создания флота из гарнизонного зонда
http://www.the-game.ru/frames/planet_fleets/on/planet/?planetid=1837%3A379&action=create_fleet_from_choosen&new_fleet_name=Crazyscript&fleetx=1837&fleety=379&page_planet=1&nf_check_33354053=on

Создание скрипта на флоте:
http://www.the-game.ru/blackframes/script_debugger/on/8529805
POST /blackframes/script_debugger/on/8529805 HTTP/1.1
action=update_fleet_variable&fleet=8529805&storedvar=&script_text=PRIVETsave=Save+and+exit

Активация скрипта (GET)
http://www.the-game.ru/blackframes/script_editor/on/8529805/?action=enable_fleet_script&fleet=8529805&mode=1
7747579

1d<r7llI
Cr@zy\/!s0r
=cut
